package cz.fi.muni.pa165.entity;

import cz.fi.muni.pa165.enums.CountryEnum;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestInstance;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import java.util.Date;

import static org.testng.Assert.assertEquals;
import static org.testng.Assert.assertNull;

@TestInstance(TestInstance.Lifecycle.PER_CLASS)
public class TeamManagerEntityTest {

    private EntityManagerFactory emf = Persistence.createEntityManagerFactory("default");

    private TeamManagerEntity teamManager;
    private TeamManagerEntity chiky;
    private TeamEntity teamEntity;
    private Date BIRTH_DATE = new Date(1645568542000L);  // 22.2.2022  22:22:22

    @BeforeAll
    void init() {
        teamManager = new TeamManagerEntity("AutistaLeader");
        teamManager.setCountry(CountryEnum.JAPAN);
        teamManager.setBirth(BIRTH_DATE);

        chiky = new TeamManagerEntity("Chiky");
        teamEntity = new TeamEntity("Team", chiky);
        chiky.setTeam(teamEntity);

        EntityManager em = emf.createEntityManager();
        try {
            em.getTransaction().begin();
            em.persist(teamManager);
            em.persist(chiky);
            em.persist(teamEntity);
            em.getTransaction().commit();
        } finally {
            if (em != null) em.close();
        }
    }

    @Test
    void attributesTest() {
        TeamManagerEntity player;
        EntityManager em = null;
        try {
            em = emf.createEntityManager();
            em.getTransaction().begin();
            player = em.find(TeamManagerEntity.class, teamManager.getId());
            assertNull(player.getTeam());
            assertEquals(player.getName(), "AutistaLeader");
            assertEquals(player.getCountry(), CountryEnum.JAPAN);
            assertEquals(player.getBirth(), BIRTH_DATE);
            em.getTransaction().commit();
        } finally {
            if (em != null) em.close();
        }
    }

    @Test
    void relationshipTeamEntity() {
        TeamEntity team;
        EntityManager em = null;
        try {
            em = emf.createEntityManager();
            em.getTransaction().begin();
            team = em.find(TeamEntity.class, teamEntity.getId());
            assertEquals(team.getManager(), chiky);
            em.getTransaction().commit();
        } finally {
            if (em != null) em.close();
        }
    }

    @Test
    void relationshipTeamManagerEntity() {
        TeamManagerEntity teamManager;
        EntityManager em = null;
        try {
            em = emf.createEntityManager();
            em.getTransaction().begin();
            teamManager = em.find(TeamManagerEntity.class, chiky.getId());
            assertEquals(teamManager.getTeam(), teamEntity);
            em.getTransaction().commit();
        } finally {
            if (em != null) em.close();
        }
    }
}
